function setup()
	room.stackable = 0
	room.visible = 1

		
	room.addActor()
	actor.setpiece = 1
	--if math.random(1,2) == 1 then
		actor.setEffectIcon("wizardnebula.png")
	--else
	--	actor.setEffectIcon("ringnebula.png")
	--end
	actor.randomizePlacement = 0
	actor.x = 3
	actor.y = 25
	actor.dist = 3
	actor.scale = 1
	actor.alpha = .7
	
	for i = 1, 20 do
		room.addActor()
		actor.setpiece = 1
		actor.setEffectIcon("nebulae1.png")
		actor.setRGB(255,150,150)
		actor.scale = .8 + math.random(1, 10) / 20
		actor.rot = math.random(0,359)
		actor.alpha = .05 + math.random() * .05
		actor.randomizePlacement = 0
		actor.x = 10
		actor.y = 26
		actor.jitterPlacement = 13
		actor.dist = 2 + math.random(1, 10) / 5
		actor.behavior = "slowspin"
	end
		
	for i = 1, 4 do
		room.addActor("terrain_asteroids.lua")
	end

	--needs to happen before adding mobs apparently?
	actor.addEvent("battlescript_bossbattle", 0)
	
	A = generator.getMobGroup("A")
	B = generator.getMobGroup("B")
	C = generator.getMobGroup("C")

	room.setWave(1)
	room.addActor(C)
	
	if generator.hardcore == 1 then
		room.addActor(A)
		room.addActor(B)
	end
	
	--actor.addWave("bubbledrone", 2, room.wave)
	
	room.setWave(2)
	room.addActor(B)
	if generator.hardcore == 1 then
		room.addActor(B)
		room.addActor(A)
		room.addActor(A)
	end
	
	room.setWave(3)
	actor.setIcon("iconmobboss1.png")
	actor.addEvent("boss_bulwark", 0)
	if game.hardcore == 0 then actor.addWave("bulwark", 1, room.wave, "", "boss_bulwark") else actor.addWave("bulwark", 1, room.wave, "hardcore", "boss_bulwark") end
	--actor.addWave("bulwark", 1, room.wave, "", "boss_bulwark")
	
	actor.nodeName = "WARNING : NEMESIS ARMOUR APPROACHING"
	--actor.addEvent("music_cryptid_demo.ogg", 0)
	--actor.addEvent("music_bosstheme_demo3.ogg", 0)
	if generator.hardcore == 1 then
		room.addActor(C)
		room.addActor(A)
	end
	
	--full heal at conclusion of fight
	--room.addActor("fullheal.lua")
	if generator.hardcore == 1 then room.addActor("extralife.lua") end
	--if game.hardcore == 0 then room.addActor("extralife.lua") end
end